#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_LuckyDrawCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_LuckyDrawCFG> Fish_LuckyDrawCFG::msSingleton(nullptr);

int Fish_LuckyDrawCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_LuckyDrawCFGData* Fish_LuckyDrawCFG::GetData(int Index)
{
	auto it = mMapData.find(Index);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_LuckyDrawCFGData>& Fish_LuckyDrawCFG::GetMapData()
{
	return mMapData;
}

void Fish_LuckyDrawCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_LuckyDrawCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_LuckyDrawCFGData data;
		data.mIndex = element->IntAttribute("Index");
		{
			const char* PinValue = element->Attribute("PinValue");
			std::vector<std::string> vecPinValue;
			boost::split(vecPinValue, PinValue, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecPinValue.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecPinValue[i].c_str(), &temp))
				{
					data.mPinValue.push_back(temp);
				}
			}
		}
		data.mStarLvl = element->IntAttribute("StarLvl");
		data.mItemType = element->IntAttribute("ItemType");
		data.mItemCount = element->IntAttribute("ItemCount");
		data.mItemValue = element->IntAttribute("ItemValue");
		{
			const char* NormalProb = element->Attribute("NormalProb");
			std::vector<std::string> vecNormalProb;
			boost::split(vecNormalProb, NormalProb, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecNormalProb.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecNormalProb[i].c_str(), &temp))
				{
					data.mNormalProb.push_back(temp);
				}
			}
		}
		{
			const char* NoChipProb = element->Attribute("NoChipProb");
			std::vector<std::string> vecNoChipProb;
			boost::split(vecNoChipProb, NoChipProb, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecNoChipProb.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecNoChipProb[i].c_str(), &temp))
				{
					data.mNoChipProb.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mIndex) != mMapData.end())std::cout <<"data refind:" << data.mIndex << std::endl;
		assert(mMapData.find(data.mIndex) == mMapData.end());
		mMapData.insert(std::make_pair(data.mIndex, data));
		element = element->NextSiblingElement();
	}
}

void Fish_LuckyDrawCFG::Load()
{
	Load("../Config/Fish_LuckyDrawCFG.xml");
}

Fish_LuckyDrawCFG* Fish_LuckyDrawCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_LuckyDrawCFG());
	}
	return msSingleton.get();
}
